package com.yardpros;

import java.sql.Connection;
import java.sql.ResultSet;
import java.sql.ResultSetMetaData;
import java.sql.Statement;
import java.sql.DriverManager;
import java.sql.SQLException;
import com.yardpros.InvalidInputException;
import com.yardpros.User;

public class DataBase
{
  private static final String DEFAULT_LOCATION = "C:/Program Files/Apache Software Foundation/Tomcat 5.5/webapps/ROOT/WEB-INF/classes/YardPros.mdb";
  
  private String username;
  private String password;
  private Connection connection;	
  private String classPath;	
  
  /**
   * This class is meant to be instantiated as a bean, and thus the setClassPath
   * then the setConnection method should be run immediatly after this bean has 
   * been constructed.
   */
  public DataBase()
  {
    username = "";
    password = "";
    connection = null;
    classPath = "";
    
    setConnection(DEFAULT_LOCATION);
    
  }
  /**
   * Sets the connection by taking in a String that has the path to the database
   * as a string
   * @param (String)location = The path to the database
   */
  public void setConnection(String location)
   {
     try
     {
        String filename = location;
        String database = "jdbc:odbc:Driver={Microsoft Access Driver (*.mdb)};DBQ="; 
        database+= filename.trim() + ";DriverID=22;READONLY=true}";
        username = "";
        password = "";
        classPath = "sun.jdbc.odbc.JdbcOdbcDriver";
        
        Class.forName(classPath);
        connection = DriverManager.getConnection(database,username,password);
         
     } 
     catch(SQLException e)
     {
       //System.out.println("Driver Manager error");
       //System.out.println(e);
     }
     catch(Exception e)
     {
       //System.out.println("forName error");
       //System.out.println(e);
     }
   }
   
  /**
   * This method gets a an entry from a specified table and column in the data base 
   * and returns it as a Stromg
   * pre: The database connection must be made and the result must be one value
   * @param (String)anEntry - the entry to compare.
   * @param (String)checkColumn - the column in the table you are checking
   * @param (String)fromColmn - the column you want.
   * @param (String)table - the name of the table you want to check
   * @return String - the resulting value of the query
   */
  public String getEntry(String entry, String checkColumn, String fromColumn, String table)
  {
    Object anEntry =(Object)"'"+entry+"'"; 
    return getEntry(anEntry,checkColumn, fromColumn, table);
  }
  /**
   * This is the overridden method for not-strings (ie primatives) that
   * does SQL querries without "'"'s 
   * pre: The database connection must be made and the result must be one value
   * @param (Object)anEntry - the entry to compare.
   * @param (String)checkColumn - the column in the table you are checking
   * @param (String)fromColmn - the column you want.
   * @param (String)table - the name of the table you want to check
   * @return String - the resulting value of the query
   */
  public String getEntry(Object entry, String checkColumn, String fromColumn, String table)
  {
    String query = "";
      
    ResultSet result = null;
    Statement stm = null;
    String ans = "";
    try
    {
      stm = connection.createStatement();
      query = "SELECT "+fromColumn+" FROM "+table+" WHERE "+checkColumn+"="+
                      entry.toString()+";";
      result = stm.executeQuery(query);
      if(result.next())
        ans = result.getObject(fromColumn).toString();
      result.close();
      stm.close();
    }
    catch(SQLException e)
    {
      //System.out.println("the query was: "+query);
      e.printStackTrace();
    }
    
    return ans;
  }
  
  /**
   * This method checks a specified table for an entry in the data base 
   * using a simple sql command.  This has no specific purpose other than
   * simple queries
   * pre: The database connection must be made
   * @param (String)entry - the entry you are looking for.
   * @param (String)column - the column in the table you are checking
   * @param (String)table - the name of the table you want to check
   */
  public boolean checkEntry(String entry, String column, String table)
  {
    ResultSet result = null;
    Statement stm = null;
    boolean ans = false;
    try
    {
      stm = connection.createStatement();
      String query = "SELECT "+column+" FROM "+table+" WHERE "+column+"='"+
                      entry+"';";
      result = stm.executeQuery(query);
      
      /*testing purposes*/
      //System.out.println(result.getString(column) );
      
      if(result.next())
        ans = true;
      else
        ans = false;
      
    result.close();
    stm.close();
      
    }
    catch(SQLException e)
    {
      //System.out.println("there was a problem with the query");
      //System.out.println(e);
    }
    
    return ans;
  }
  
  /**
   * This method checks a username and password from a database that has a table
   * named 'users' and column names 'username' and 'password'
   * pre: The database must have a table named users, and colmns named username
   *      named 'username' and 'password'
   *@param (String)username - The username as a string
   *@param (String)password - the username's password
   *@return boolean - if the login is successful
   */
  public boolean checkLogin(String username, String password)
  {
    ResultSet rst = null;
    Statement stm = null;
    boolean ans = false;
    try
    {
      stm = connection.createStatement();
      String query = "SELECT * FROM users WHERE username = '"+username
                      +"' AND password = '"+password+"';";
      rst = stm.executeQuery(query);
      
      ans = rst.next();
      rst.close();
      stm.close();
    }
    catch(SQLException e)
    {
      //System.out.println("there was a problem with the query");
      //System.out.println(e);
    }
    
    return ans;
  }
  /**
   * This method gets a username for an admin to change for the database
   * @param (String)username - the user to get
   * @return (User) - the user
   * @throws InvalidInputException if the username does not exist
  */
  public com.yardpros.User getUser(String username) throws InvalidInputException
  {
    ResultSet rst = null;
    Statement stm = null;
    com.yardpros.User user = new com.yardpros.User();
    if( !checkEntry(username,"username","users") )
       throw new InvalidInputException("'"+username+"' is an invalid Username");
    try
    {
      stm = connection.createStatement();
      String query = "SELECT * FROM users WHERE username = '"+username+"';";
      //testing
      //System.out.println(query);
      rst = stm.executeQuery(query);
      // this gets all of the columns and puts them in the user.
      rst.next();
      int cols = rst.getMetaData().getColumnCount();
      for(int i=1;i<=cols;i++)
        user.put(rst.getMetaData().getColumnName(i),
                 rst.getString(rst.getMetaData().getColumnName(i)) );
        
      //testing
      //System.out.println(user.toString());
      rst.close();
      stm.close();
    }
    catch(SQLException e)
    {
      e.printStackTrace();
    }
    
    return user;
  }
  /**
   * an internal method for running a general query that updates the data
   * pre: a database connection must be made
   * post: the data base is updated
   */
  private void executeUpdate(String query)
                      throws SQLException
  {
    Statement stm = connection.createStatement();
    if( stm.executeUpdate(query) < 1)
    {
      stm.close();
      throw new SQLException("the update was not successful");
    }
    stm.close();
  }
  /**
   * This returns a product given its product id
   * @param int - the product id to retrieve
   * @return Product - the product.
   */
  public Product getProduct(int productID) throws InvalidInputException,
                                                  SQLException
  {
    Statement stm = connection.createStatement();
    String query = "SELECT * FROM products WHERE productID = "+productID+";";
    Product product = new Product();
    
    ResultSet rst = stm.executeQuery(query);
    if(rst.next())
      for(int i =1; i<= rst.getMetaData().getColumnCount(); i++)
        product.put(rst.getMetaData().getColumnName(i), rst.getObject(i));
    else
      throw new InvalidInputException("That ID does not exist");
    
    return product;
  }

   /**
   * This method returns a user bean for use of a login session.
   * if the names are invalid an InvalidInputException is thrown.
   * @param (String)username - the username to login.
   * @param (password)password - the username associated with the password.
   * @throws InvalidInputException - if the either the username doesn't exist or
   *                                 the password does not match.
   */
   public com.yardpros.User login(String username, String password) 
                                                    throws InvalidInputException
   {
    ResultSet rst = null;
    Statement stm = null;
    com.yardpros.User user = new com.yardpros.User();
    
    try
    {
      if( !checkEntry(username, "username", "users") )
        throw new InvalidInputException(username + " is not a valid username");
      
      stm = connection.createStatement();
      String query = "SELECT * FROM users WHERE username = '"+username
                      +"' AND password = '"+password+"';";
      System.out.println(query);
      rst = stm.executeQuery(query);
      
      //checks to see if the query is empty
      if( !rst.next() )
        throw new InvalidInputException("Your password did not match");
      
      ResultSetMetaData metaData = rst.getMetaData();
      for(int i=0; i<metaData.getColumnCount(); i++)
      {
        String name = metaData.getColumnName(i+1);
        //System.out.println(name);
        user.put(name,rst.getString(name));
      }
      
      rst.close();
      stm.close();
    }
    catch(SQLException e)
    {
      //System.out.println("there was a problem with the query");
      e.printStackTrace();
    }
    
    return user;
   }
    
    /**
    * This returns a java.sql.ResultSet that contains all of the table rows in
    * the database.
    * @param - (String)table - The name of the table with th result set
    * @return ResultSet - Containing all the products in the database.
    */ 
    public java.sql.ResultSet getAll(String table)
    {
      ResultSet rst = null;
      Statement stm = null;
      try
      {
        stm = connection.createStatement();
        String query = "SELECT * FROM "+table+";";
        rst = stm.executeQuery(query);
        
      }
      catch(SQLException e)
      {
        e.printStackTrace();
      }
      
      return rst;
    }
    
    /**
    * This returns a java.sql.ResultSet that contains all of the table rows in
    * the database in reverse order
    * @param - (String)table - The name of the table with th result set
    * @param - sets the data to be reversed
    * @return ResultSet - Containing all the products in the database.
    */ 
    public java.sql.ResultSet getAll(String table, String col)
    {
      ResultSet rst = null;
      Statement stm = null;
      try
      {
        stm = connection.createStatement();
        String query = "SELECT * FROM "+table+" ORDER BY "+col+" DESC;";
        rst = stm.executeQuery(query);
        
      }
      catch(SQLException e)
      {
        e.printStackTrace();
      }
      
      return rst;
    }
    
  /**
   *This method makes a transaction with a cart bean.
   *@param (Cart)cart - a shopping cart to add to the data base
   *@param (User)user - the user active durring the purchase
   *@return String - the final cost of the items
   */
  public double add(com.yardpros.Cart cart, com.yardpros.User user)
                      throws SQLException, InvalidInputException
  {
   double total = 0;
   for(int key : (java.util.Set<Integer>)cart.keySet() )
   {
     
     String query1 = "INSERT INTO transactions (username, creditcard,"+
                         " creditcardnumber, expirationdate,"+
                         " confirmnumber, productID, quantity) "+
                         "VALUES("+
                         "'"+user.get("username")+"',"+
                         "'"+cart.getCreditCard()+"',"+
                         "'"+cart.getCreditCardNumber()+"',"+
                         "'"+cart.getExpirationDate()+"',"+
                         "'"+cart.getConfirmNumber()+"',"+
                         " "+key+" ,"+
                         " "+cart.get(key)+" );";
     
      //resets connection to ensure thread-safe
      connection.commit();
      
      /******************    perhaps unecessary     ***************************/
      //for getting the price of the product
      Statement stm = connection.createStatement();
      String query2 = "SELECT price FROM products WHERE productID = "+key+";";
      
      //System.out.println("query2 is: "+query2);
      ResultSet rst = stm.executeQuery(query2);
      
      if(rst.next())
        total = total+(Integer)cart.get(key)*rst.getDouble("price");
      /***********************************************************************/
      
      //here is where we update the stock
      int deduction = ((Integer)(cart.get(key))).intValue();
      int quantity = Integer.parseInt(getEntry(key,"productID","stock","products"));
      String query3 = "UPDATE products SET stock="+(quantity-deduction)+
                      " WHERE productID="+key+";";
      
      //testing
      //System.out.println("the stock query: " +query3);
      
      executeUpdate(query1);
      executeUpdate(query3);
      //resets connection to ensure thread-safe
      connection.commit();
   }
   
   
   //testing purposes
   //System.out.println("the querry is: "+query);
   //System.out.println("the cart transaction is: "+cart.toString());
   
   return total;
  }
  
    
  /**
  * This method adds a user to the database    * pre: the user must be initialized.
  * @param (com.yardpros.User) user - the user to add
  * @throws InvalidInputException - if the username already exists
  * @throws SQLException - if the update was unsuccessful
  */
  public void add(com.yardpros.User user) 
                    throws SQLException, InvalidInputException
  {
    if( checkEntry((String)user.get("username") ,"username","users") )
       throw new InvalidInputException("There already is a user with that name");
       
   String prefix = "INSERT INTO users ";
   addData(prefix, user);
  }
   /* ***** a better (more general way) way is implemented on line 483 *******
    String valueQuery = new String();
    String keyQuery = new String();
    //check for duplicate usernames
    if( checkEntry( (String)user.get("username") , "username", "users"))
    {
      throw new InvalidInputException("That username is already in use");
    }
    //build the query
    for(String i : (java.util.Set<String>)user.keySet() )
      if(!(i.startsWith("!")) )                                       //excludes the fields beginning with '!'
      {
        valueQuery = user.get(i) == (null) ? valueQuery + "','NULL" 
                                           : valueQuery + "','"+user.get(i);  //this builds a list of values
        keyQuery = keyQuery + " , "+i;                //this builds a list of keys
      }
    
    keyQuery = "("+keyQuery.substring(2)+")";
    valueQuery = "("+valueQuery.substring(2)+"')"; 
    String query = "INSERT INTO users"+keyQuery+" VALUES "+valueQuery+";";     //some quick formatting
    
    executeUpdate(query);
    //testing purposes
    System.out.println("The query is: "+query);
    //System.out.println("the user is: "+user.toString());
  }*/
  
 /**
  * This method updates a new user. If the passwords do not match or the user
  * name does not exist then the update will be unsuccessful.
  * @param - (User)The user to update
  * @throws - InvalidInputException - if the username does not exist and the 
  * username and password do not match
  */
 public void update(com.yardpros.User user)
                throws InvalidInputException, SQLException
 {
   String prefix = "UPDATE users ";
   updateData(prefix, user, "username", user.get("username"));
 }
 /* ***************** A better way is implemented below ***********************
    //This should check out and will prevent 
    if( !checkEntry( (String)user.get("username") , "username", "users"))
    {
      throw new InvalidInputException("somehow the username got changed");
    }
    //build the query
    String query = new String();
    for(String i : (java.util.Set<String>)user.keySet() )
      if(!(i.startsWith("!")) )                                       //excludes the fields beginning with '!'
        query = user.get(i) == (null) ? query + "', "+i+" = 'NULL" 
                                      : query + "', "+i+" = '"+user.get(i);    //this builds the query, with my favorite op-the ternary
    
    query =  "UPDATE users SET "+query.substring(2)+"' WHERE username = '"+user.get("username")+"';";     //delete the first ', and tack on the end of the query
    
    //testing purposes
    //System.out.println("The query is: "+query);
    //System.out.println("the user is: "+user.toString());
    executeUpdate(query);
 }*/ 
  /**
   * This is for adding products to the database and is a wrapper for the general
   * method addData.
   * @param (Product)product - a Product to add to the database
   */
  public void add(com.yardpros.Product product) throws SQLException, InvalidInputException
  {
    if( checkEntry((String)product.get("name") ,"name","products") )
       throw new InvalidInputException("There already is a product with that name");
     
    String queryPrefix = "INSERT INTO products ";
    addData(queryPrefix, product);
  }
  public void update(com.yardpros.Product product) throws SQLException, InvalidInputException
  {
    String queryPrefix = "UPDATE products ";
    updateData(queryPrefix, product);
  }
  public void update(com.yardpros.Product product,
                     Object primaryKey,Object primaryValue) throws SQLException, InvalidInputException
  {
    String queryPrefix = "UPDATE products ";
    updateData(queryPrefix, product, primaryKey, primaryValue);
  }
  /**
   * This is a general method for adding rows from Hashtables to the database
   * @param (String)prefix - depending on the wrapped function.
   * @param (Product)product - The row to add
   */
  public void addData(String prefix, java.util.LinkedHashMap row) throws SQLException, InvalidInputException
  {
    String keys = buildKeys(row);
    String values = buildValues(row);
    
    String query = prefix+keys+" VALUES "+values+";";
    
    //testing
    //System.out.println("the keys are:" +keys);
    //System.out.println("the vals are:" +values);
    //System.out.println("the query is: "+query);
    
    executeUpdate(query);
  }
  /**
   * This deletes user frome the database
   * @param LinkedHashMap - the row to delete
   */
  public void remove(com.yardpros.User row) 
                                      throws SQLException, InvalidInputException
  {
    String query = "DELETE FROM users WHERE username='"+row.get("username")+"';";
    executeUpdate(query);
  }  
  /**
   * This deletes a product from the database
   * @param LinkedHashMap - the row to delete
   */
  public void remove(com.yardpros.Product row) 
                                      throws SQLException, InvalidInputException
  {
    String query = "DELETE FROM products WHERE productID="+row.get("productID")+";";
    executeUpdate(query);
  }
  /**
   * This is a wrapper for updateData when the primarykey is defaulted to the first
   * value in the LinkedHashMap
   * @param prefix - the prefix that contains info on what row is being updated
   * @param LinkedHashMap - the data to add
   */
  public void updateData(String prefix, java.util.LinkedHashMap row)
                              throws SQLException, InvalidInputException
  {
    Object primaryKey = ((java.util.Set<String>)row.keySet()).toArray()[0];
    Object primaryValue = row.get(primaryKey);
    updateData(prefix, row, primaryKey, primaryValue);
  }
  /**
   * This is a general method for adding rows to the database from HashTables
   * @param prefix - the prefix that contains info on what row is being updated
   * @param LinkedHashMap - the data to add
   * @param PrimaryKey - the position of th key value of the data to add
   */
  public void updateData(String prefix, java.util.LinkedHashMap row, 
                         Object primaryKey, Object primaryValue)
                            throws SQLException, InvalidInputException
  {
    String values = buildUpdateValues(row);
    
    //again with the ternary operator to see if the key needs quotes
    String query = needsQuotes(primaryValue) ? 
            prefix + "SET "+values+" WHERE "+primaryKey+" = '"+primaryValue+"';":
            prefix + "SET "+values+" WHERE "+primaryKey+" = "+primaryValue+";";
    
    //testing
    //System.out.println("the query is: "+query);
    executeUpdate(query);
  }
  /**
   * This builds the 'key = value' format for the stupid ass update query
   * @param LinkedHashMap - the data to build from
   * @String the resulting syntax for the update query
   */
  public String buildUpdateValues(java.util.LinkedHashMap row)
  {
    String values = "";
    String keys = "";
    for(String key : (java.util.Set<String>)row.keySet())
    {
      /* this excludes all values preceded with '!' */
      if(!(key.startsWith("!") || key.startsWith("00")) )
      {
        // use the ol' ternary op to add quotes or not
        values = needsQuotes( row.get(key) ) ? values + ", "+key+"='"+row.get(key)+"'":
                                               values + ", "+key+"="+row.get(key);
      }
    }
    
    return values.substring(2);
  }
  /**
   * this is a method to build values for SQL queries that exludes "'"'s for
   * Integers and Doubles
   * @param LinkedHashMap - the data to take the values from
   */
  private String buildValues(java.util.LinkedHashMap row)
  {
    String values = "";
    for(String key : (java.util.Set<String>)row.keySet())
    {
      // this excludes all values preceded with '!' or 00
      if(!(key.startsWith("!") || key.startsWith("00") ) )
      {
        // use the ol' ternary op to add quotes or not
        values = needsQuotes( row.get(key) ) ? values + ", '"+row.get(key)+"'":
                                               values + ", "+row.get(key);
      }
    }
    
    values = "("+values.substring(2)+")";
    return values;
  }
  
  /**
   * This method checks to see if a an object needs "'"'s in an SQL query, ie it is
   * a double or an int
   * @param Object - the object to see the type of
   * @return boolean - wether it is an int or a double
   */
  public static boolean needsQuotes(Object e)
  {
    boolean ans = false;
    try
    { 
      Double test;
      test = (Double)e;
      ans = false;
    }
    catch(ClassCastException e1)
    {
      try
      {
        Integer test;
        test = (Integer)e;
        ans = false;
      }
      catch(ClassCastException e2)
      {
        //both casts were unsuccessful thus it needs quotes
        ans = true;
      }
    }
    return ans;
  }
  /**
   * Builds an String for an SQL query for keys from a LinkedHashMap
   * pre: all the keys in the linked hash should be strings
   * @param LinkedHashMap - the data to put into the string
   */
  public String buildKeys(java.util.LinkedHashMap row)
  {
    String keys = "";
    for(String key : (java.util.Set<String>)row.keySet())
    {
      if(!(key.startsWith("!") || key.startsWith("00")) )
        keys = keys+" ,"+key;
    }
    keys = "("+keys.substring(2)+")";
    return keys;
  }
  
  /**
  * This closes the connection with the database.  Make sure to run this every
  * time setConnection is run.
  * pre: a connnection with the database is set up.
  * post: the connection is closed
  */
  public void closeConnection() throws SQLException
  {
     connection.close();
  }
/*********** Get and Set methods for (useless) instance variables associated with database ********
 */
  /**
	 * Returns the value of classPath.
	 */
	public String getClassPath()
	{
		return classPath;
	}

	/**
	 * Sets the value of classPath.
	 * @param classPath The value to assign classPath.
	 */
	public void setClassPath(String classPath)
	{
		this.classPath = classPath;
	}
    /**
     * Returns the value of username.
     */
    public String getUsername()
    {
      return username;
    }
  
    /**
     * Sets the value of username.
     * @param username The value to assign username.
     */
    public void setUsername(String username)
    {
      this.username = username;
    }
  
    /**
     * Returns the value of password.
     */
    public String getPassword()
    {
      return password;
    }
  
    /**
     * Sets the value of password.
     * @param password The value to assign password.
     */
    public void setPassword(String password)
    {
      this.password = password;
    }
  
    /**
     * Returns the value of connection.
     */
    public Connection getConnection()
    {
      return connection;
    }
}
