package com.yardpros;

import java.util.LinkedHashMap;

public class Product extends LinkedHashMap
{
  private int productID;
  private int amount;
  private double price;
  private String description;		  
  
  public Product()
  {
    put("name", "");
    put("stock", 0);
    put("price", 0);
    put("description", "");
  }
  
  /**
   * This checks the entries of a product and throws an exception if it any are
   * invalid
   * @throws InvalidInputException - if any of the values are not valid
   */
  public void checkEntries() throws InvalidInputException
  {
    try
    {
      int test1 = Integer.parseInt(get("stock").toString());
      double test2 = Double.parseDouble(get("price").toString());
    }
    catch(NumberFormatException e)
    {
      throw new InvalidInputException("Non number value");
    }
  }
  
}
